"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Timers {
    constructor($processService) {
        this.$processService = $processService;
        this.pendingIntervalIds = [];
        this.$processService.attachToProcessExitSignals(this, () => {
            _.each(this.pendingIntervalIds, clearInterval);
        });
    }
    setInterval(callback, ms, ...args) {
        const timer = setInterval(callback, ms, args);
        this.pendingIntervalIds.push(timer);
        return timer;
    }
    clearInterval(intervalId) {
        clearInterval(intervalId);
        _.remove(this.pendingIntervalIds, id => id === intervalId);
    }
}
exports.Timers = Timers;
$injector.register("timers", Timers);
